(* $Id: omapping.mli,v 1.5 1998/09/01 09:31:34 garrigue Exp $ *)

(* An embryo of class hierarchy for mappings.
   4 implementations of Omapping.c are provided:

    * Omapping.alist: association lists
    * Omap.c, Omap.f: BDD-based maps, imperative and functional versions
    * Ohashtbl.c: Hash tables

   Omapping.alist and Omap.f support the stronger functional interface
   Omapping.f.
   We have also Ohashtbl.c <: Omap.c *)

class virtual ['a,'b] c : object
  method virtual find : key:'a -> 'b
  method virtual iter : fun:(key:'a -> data:'b -> unit) -> unit
end

class virtual ['a,'b] f : object
  method virtual find : key:'a -> 'b
  method virtual iter : fun:(key:'a -> data:'b -> unit) -> unit
  method virtual fold :
      'c. fun:(key:'a -> data:'b -> acc:'c -> 'c) -> acc:'c -> 'c
end

class ['a,'b] alist : ('a * 'b) list -> ?eq:[logical physical] ->  object
      (* A class wrapper for association lists.
	 If [eq] is [`physical] then use List.assq for find,
	 otherwise use List.assoc. *)
  method find : key:'a -> 'b
  method iter : fun:(key:'a -> data:'b -> unit) -> unit
  method fold :
      'c. fun:(key:'a -> data:'b -> acc:'c -> 'c) -> acc:'c -> 'c
end
